require 'socket'

module Redify

  class Application

    class << self

      def install
        return false unless installable?
        p, n, h = get_data
        h.sadd("#{p}", n)
        h.sadd("#{p}:#{n}:PIDs", $$)
      end

      def uninstall
        p, n, h = get_data
        h.srem("#{p}", n)
        h.srem("#{p}:#{n}:PIDs", $$)
        true
      end

      private

      def prefix
        "RedifyApps:#{Socket.gethostname}"
      end

      def installable?
        _, n, h = get_data
        n && h
      end

      # returns prefix, namespace and handler
      def get_data
        [prefix, Redify::Settings.namespace, Redify::Settings.default_handler]
      end


    end

  end

end