module Redify

  class Settings

    class << self

      attr_accessor :always_redify_associations, :raise_redis_errors
      attr_reader :namespace

      def namespace=(value)
        return @namespace if @namespace == value
        # remoces old namespace install
        Redify::Application.uninstall
        @namespace = value
        Redify::Application.install
      end

      def set_default_options
        # silently falls back to ActiveRecord when Redis is unavailable
        raise_redis_errors = false

        # only redify associations when specified
        always_redify_associations = false

        # default namespace
        namespace = "Redify"
      end

      def default_handler=(handler)
        @default_handler = handler
        Redify::Application.install
      end
      attr_reader :default_handler

    end

  end

end